//+------------------------------------------------------------------+
//|                                                        CCI_2.mq4 |
//|                                   Copyright  2014, PimpMyEA.com |
//|                                         http://www.pimpmyea.com/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2014, PimpMyEA.com"
#property  link      "http://www.pimpmyea.com/"
//----
#property indicator_separate_window

#property indicator_buffers 8

#property indicator_color8 Yellow

#property indicator_color4 Lime
#property indicator_color5 Lime
#property indicator_color6 Red
#property indicator_color7 Red

#property indicator_width8 3

#property indicator_width4 3
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 3

#property indicator_level1 0
#property indicator_levelcolor White

//---- input parameters
extern int CCIPeriod = 14;
//---- buffers
double CCIBuffer[];
double RelBuffer[];
double DevBuffer[];
double MovBuffer[];

double BarUP_up[];
double BarUP_down[];
double BarDOWN_up[];
double BarDOWN_down[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(8);
   SetIndexBuffer(0, RelBuffer);
   SetIndexBuffer(1, DevBuffer);
   SetIndexBuffer(2, MovBuffer);
//---- indicator lines
   SetIndexStyle(7, DRAW_LINE);
   SetIndexBuffer(7, CCIBuffer);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(3, BarUP_up);
   SetIndexStyle(4, DRAW_HISTOGRAM);
   SetIndexBuffer(4, BarUP_down);
   SetIndexStyle(5, DRAW_HISTOGRAM);
   SetIndexBuffer(5, BarDOWN_up);
   SetIndexStyle(6, DRAW_HISTOGRAM);
   SetIndexBuffer(6, BarDOWN_down);

//----
   if(CCIPeriod <= 0)
       CCIPeriod = 14;
//----
   SetIndexDrawBegin(0, CCIPeriod);
  
//---- name for DataWindow and indicator subwindow label
   short_name="CCI(" + CCIPeriod + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Commodity Channel Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i, k, counted_bars = IndicatorCounted();
   double price, sum, mul; 
   if(CCIPeriod <= 1)
       return(0);
   if(Bars <= CCIPeriod) 
       return(0);
//---- initial zero
   if(counted_bars < 1)
     {
       for(i = 1; i <= CCIPeriod; i++) 
           CCIBuffer[Bars-i] = 0.0;
       for(i = 1; i <= CCIPeriod; i++) 
           DevBuffer[Bars-i] = 0.0;
       for(i = 1; i <= CCIPeriod; i++) 
           MovBuffer[Bars-i] =0.0;
     }
//---- last counted bar will be recounted
   int limit = Bars - counted_bars;
   if(counted_bars > 0) 
       limit++;
//---- moving average
   for(i = 0; i < limit; i++)
       MovBuffer[i] = iMA(NULL, 0, CCIPeriod, 0, MODE_SMA, PRICE_TYPICAL, i);
//---- standard deviations
   i = Bars - CCIPeriod + 1;
   if(counted_bars > CCIPeriod - 1) 
       i = Bars - counted_bars - 1;
   mul = 0.015 / CCIPeriod;
   while(i >= 0)
     {
       sum = 0.0;
       k = i + CCIPeriod - 1;
       while(k >= i)
        {
          price =(High[k] + Low[k] + Close[k]) / 3;
          sum += MathAbs(price - MovBuffer[i]);
          k--;
        }
       DevBuffer[i] = sum*mul;
       i--;
     }
   i = Bars - CCIPeriod + 1;
   if(counted_bars > CCIPeriod - 1) 
       i = Bars - counted_bars - 1;
   while(i >= 0)
     {
       price = (High[i] + Low[i] + Close[i]) / 3;
       RelBuffer[i] = price - MovBuffer[i];
       i--;
     }
//---- cci counting
   i = Bars - CCIPeriod + 1;
   if(counted_bars > CCIPeriod - 1) 
       i = Bars - counted_bars - 1;
   while(i >= 0)
     {
       if(DevBuffer[i] == 0.0) 
           CCIBuffer[i] = 0.0;
       else 
           CCIBuffer[i] = RelBuffer[i] / DevBuffer[i];
           
       if (CCIBuffer[i] > 0){
           BarDOWN_up[i] = 0;
           BarDOWN_down[i] = 0;
           if (CCIBuffer[i] >= CCIBuffer[i+1]){
               BarUP_up[i] = CCIBuffer[i];
               BarUP_down[i] = 0;
           } else {
               BarUP_down[i] = CCIBuffer[i];
               BarUP_up[i] = 0;
           }
       }    

       if (CCIBuffer[i] < 0){
           BarUP_up[i] = 0;
           BarUP_down[i] = 0;
           if (CCIBuffer[i] <= CCIBuffer[i+1]){
               BarDOWN_down[i] = CCIBuffer[i];
               BarDOWN_up[i] = 0;
           } else {
               BarDOWN_up[i] = CCIBuffer[i];
               BarDOWN_down[i] = 0;
           }
       }    
       i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+