//+------------------------------------------------------------------+
//|                                                  Demark_Bars.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color2  Green
#property  indicator_color3  Red

#property indicator_width2 3
#property indicator_width3 3

#property indicator_maximum 1
#property indicator_minimum 0

extern int period = 14;

double demark[];
double demark_up[];
double demark_down[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexBuffer(0,demark);
   SetIndexBuffer(1,demark_up);
   SetIndexBuffer(2,demark_down);
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);

   IndicatorShortName("Demark Bars("+period+")");


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i,limit;
//----
   limit=Bars-counted_bars;         

   for(i=0; i<limit; i++)
      demark[i] = iDeMarker(Symbol(),0,period,i);      

   for(i=0; i<limit; i++){
   
      if (demark[i] == demark[i+1]){
         if (demark_up[i+1] == 1){
            demark_up[i] = 1;
            demark_down[i] = EMPTY_VALUE;
         }else{
            demark_down[i] = 1;
            demark_up[i] = EMPTY_VALUE;
         }
      }
      
      if (demark[i] > demark[i+1]){
         demark_up[i] = 1;
         demark_down[i] = EMPTY_VALUE;
      }
      
      if (demark[i] < demark[i+1]){
         demark_down[i] = 1;
         demark_up[i] = EMPTY_VALUE;
      }

   }
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+