//+------------------------------------------------------------------+
//|                                                    psar_Bars.mq4 |
//|                                   Copyright  2014, PimpMyEA.com |
//|                                         http://www.pimpmyea.com/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2014, PimpMyEA.com"
#property  link      "http://www.pimpmyea.com/"

#property indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Gray

#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3

#property indicator_maximum 1
#property indicator_minimum 0

extern double step = 0.1;
extern double maximum = 0.4;

double psar[];
double psar_up[];
double psar_down[];
double psar_flat[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0,psar);
   SetIndexBuffer(1,psar_up);
   SetIndexBuffer(2,psar_down);
   SetIndexBuffer(3,psar_flat);

   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);

   IndicatorShortName("PSAR Bars");


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i,limit;
//----
   limit=Bars-counted_bars;         

   for(i=0; i<limit; i++)
      psar[i] = iSAR(Symbol(),0,step,maximum,i);     

   for(i=0; i<limit; i++){

      if (psar[i] == Close[i]){
         psar_flat[i] = 1;
         psar_up[i] = EMPTY_VALUE;
         psar_down[i] = EMPTY_VALUE;
      }
         
      if (psar[i] < Close[i]){
         psar_up[i] = 1;
         psar_down[i] = EMPTY_VALUE;
         psar_flat[i] = EMPTY_VALUE;
      }
      
      if (psar[i] > Close[i]){
         psar_down[i] = 1;
         psar_up[i] = EMPTY_VALUE;
         psar_flat[i] = EMPTY_VALUE;
      }

   }
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+