//+------------------------------------------------------------------+
//|                                                  HullMA_Bars.mq4 |
//|                                   Copyright  2014, PimpMyEA.com |
//|                                         http://www.pimpmyea.com/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2014, PimpMyEA.com"
#property  link      "http://www.pimpmyea.com/"

#property indicator_separate_window

#property indicator_buffers 5
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_width3 3
#property indicator_width4 3
#property indicator_maximum 1
#property indicator_minimum 0

//---- input parameters
extern int       HMA_period=10;
extern int       HMA_price=PRICE_CLOSE;
extern int       HMA_mode=MODE_LWMA;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

int        draw_begin0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);

   draw_begin0=HMA_period+MathFloor(MathSqrt(HMA_period));
   SetIndexDrawBegin(2,draw_begin0);
   SetIndexDrawBegin(3,draw_begin0);

   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("HMA Bars("+HMA_period+")");
   SetIndexLabel(0,"Hull Moving Average BARS");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   double d1;
   double d2;   
   int limit;
//----
   if(counted_bars>0) counted_bars--;   
   limit=Bars-counted_bars;         
   for(int i=0; i<limit; i++){               
         d1=iMA(NULL,0,HMA_period,0,HMA_mode,HMA_price,i);
         d2=iMA(NULL,0,MathRound(HMA_period/2),0,HMA_mode,HMA_price,i);         
         ExtMapBuffer2[i]=(2*d2)-(d1);         
   }
   for(i=0; i<limit; i++)
           ExtMapBuffer1[i]=iMAOnArray(ExtMapBuffer2,0,MathFloor(MathSqrt(HMA_period)),0,MODE_LWMA,i);
           
   for(i=0; i<limit; i++){
               ExtMapBuffer3[i]=0;
               ExtMapBuffer4[i]=0;
           
           if(ExtMapBuffer1[i]>ExtMapBuffer1[i+1]){
               ExtMapBuffer3[i]=1;
           }else{
               ExtMapBuffer4[i]=1;
           }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+