//+------------------------------------------------------------------+
//|                                                       MACD_2.mq4 |
//|                                   Copyright  2014, PimpMyEA.com |
//|                                         http://www.pimpmyea.com/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2014, PimpMyEA.com"
#property  link      "http://www.pimpmyea.com/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Yellow
#property indicator_width2 3
#property indicator_width3 3
#property indicator_style4 2
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];
double     MacdBuffer_up[];
double     MacdBuffer_down[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_LINE);

   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(3,SignalBuffer);
   SetIndexBuffer(1,MacdBuffer_up);
   SetIndexBuffer(2,MacdBuffer_down);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);

   for(i=0; i<limit; i++){
      if (MacdBuffer[i] > MacdBuffer[i+1]){
         MacdBuffer_up[i] = MacdBuffer[i];
         MacdBuffer_down[i] = EMPTY_VALUE;
      } else {
         MacdBuffer_down[i] = MacdBuffer[i];
         MacdBuffer_up[i] = EMPTY_VALUE;
      }
   }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+